﻿using PlumbingRepairContracts.BindingModels;
using PlumbingRepairContracts.ViewModels;
using PlumbingRepairDataModels.Models;
using System.Runtime.Serialization;
using System.Xml.Linq;

namespace PlumbingRepairFileImplement.Models
{
	[DataContract]
	public class Implementer : IImplementerModel
	{
		[DataMember]
		public string ImplementerFIO { get; set; } = string.Empty;
		[DataMember]
		public string Password { get; set; } = string.Empty;
		[DataMember]
		public int WorkExperience { get; set; }
		[DataMember]
		public int Qualification { get; set; }
		[DataMember]
		public int Id { get; set; }

		public static Implementer? Create(ImplementerBindingModel? model)
		{
			if (model == null)
			{
				return null;
			}
			return new Implementer()
			{
				Id = model.Id,
				ImplementerFIO = model.ImplementerFIO,
				Password = model.Password,
				WorkExperience = model.WorkExperience,
				Qualification = model.Qualification
			};
		}
		public static Implementer? Create(XElement element)
		{
			if (element == null)
			{
				return null;
			}
			return new Implementer()
			{
				Id = Convert.ToInt32(element.Attribute("Id")!.Value),
				ImplementerFIO = element.Element("ImplementerFIO")!.Value,
				Password = element.Element("Password")!.Value,
				WorkExperience = Convert.ToInt32(element.Element("WorkExperience")!.Value),
				Qualification = Convert.ToInt32(element.Element("Qualification")!.Value)
			};
		}
		public void Update(ImplementerBindingModel? model)
		{
			if (model == null)
			{
				return;
			}
			ImplementerFIO = model.ImplementerFIO;
			Password = model.Password;
			WorkExperience = model.WorkExperience;
			Qualification = model.Qualification;
		}
		public ImplementerViewModel GetViewModel => new()
		{
			Id = Id,
			ImplementerFIO = ImplementerFIO,
			Password = Password,
			WorkExperience = WorkExperience,
			Qualification = Qualification
		};
		public XElement GetXElement => new("Implementer",
			new XAttribute("Id", Id),
			new XElement("ImplementerFIO", ImplementerFIO),
			new XElement("Password", Password),
			new XElement("WorkExperience", WorkExperience),
			new XElement("Qualification", Qualification));
	}
}
